LibreOffice LibreOffice 25.2 SDK API Reference

Public Member Functions | List of all members
XInputStream Interface Referencepublished

This is the basic interface to read data from a stream. More...

`import"XInputStream.idl";`

Inheritance diagram for XInputStream:

## Public Member Functions
long | readBytes ([out] sequence< byte > aData, [in] long nBytesToRead) raises ( com::sun::star::io::NotConnectedException, com::sun::star::io::BufferSizeExceededException, com::sun::star::io::IOException)
| reads the specified number of bytes in the given sequence. More...
long | readSomeBytes ([out] sequence< byte > aData, [in] long nMaxBytesToRead) raises ( com::sun::star::io::NotConnectedException, com::sun::star::io::BufferSizeExceededException, com::sun::star::io::IOException )
| reads the available number of bytes, at maximum nMaxBytesToRead. More...
void | skipBytes ([in] long nBytesToSkip) raises ( com::sun::star::io::NotConnectedException, com::sun::star::io::BufferSizeExceededException, com::sun::star::io::IOException )
| skips the next nBytesToSkip bytes (must be positive). More...
long | available () raises ( com::sun::star::io::NotConnectedException, com::sun::star::io::IOException )
| states how many bytes can be read or skipped without blocking. More...
void | closeInput () raises ( com::sun::star::io::NotConnectedException, com::sun::star::io::IOException)
| closes the stream. More...
Public Member Functions inherited from XInterface
any | queryInterface ([in] type aType)
| queries for a new interface to an existing UNO object. More...
void | acquire ()
| increases the reference counter by one. More...
void | release ()
| decreases the reference counter by one. More...

## Detailed Description

This is the basic interface to read data from a stream.

See the streaming document for further information on chaining and piping streams.

## Member Function Documentation

## ◆ available()

long available | ( |  | ) |
raises | ( | com::sun::star::io::NotConnectedException,
|  | com::sun::star::io::IOException
| ) |  |

states how many bytes can be read or skipped without blocking.

Note: This method offers no information on whether the EOF has been reached.

## ◆ closeInput()

void closeInput | ( |  | ) |
raises | ( | com::sun::star::io::NotConnectedException,
|  | com::sun::star::io::IOException
| ) |  |

closes the stream.

Users must close the stream explicitly when no further reading should be done. (There may exist ring references to chained objects that can only be released during this call. Thus not calling this method would result in a leak of memory or external resources.)

## ◆ readBytes()

long readBytes | ( | [out] sequence< byte > | aData,
|  | [in] long | nBytesToRead
| ) |  |
raises | ( | com::sun::star::io::NotConnectedException,
|  | com::sun::star::io::BufferSizeExceededException,
|  | com::sun::star::io::IOException
| ) |  |

reads the specified number of bytes in the given sequence.

The return value specifies the number of bytes which have been put into the sequence. A difference between nBytesToRead and the return value indicates that EOF has been reached. This means that the method blocks until the specified number of bytes are available or the EOF is reached.

Parameters

  aData | after the call, the byte sequence contains the requested number of bytes (or less as a sign of EOF). C++ only : Note that for unbridged (e.g., in-process) calls, using the same sequence for repetitive readBytes()-calls can bear a performance advantage. The callee can put the data directly into the sequence so that no buffer reallocation is necessary. But this holds only when neither caller nor callee keep a second reference to the same sequence. the sequence is pre-allocated with the requested number of bytes. the same sequence is reused (simply preallocating a new sequence for every call bears no advantage). the call is not bridged (e.g., between different compilers or different processes). If the same 'optimized' code runs against an interface in a different process, there is an unnecessary memory allocation/deallocation (the out parameter is of course NOT transported over the connection), but this should be negligible compared to a synchron call.
  nBytesToRead | the total number of bytes to read

## ◆ readSomeBytes()

long readSomeBytes | ( | [out] sequence< byte > | aData,
|  | [in] long | nMaxBytesToRead
| ) |  |
raises | ( | com::sun::star::io::NotConnectedException,
|  | com::sun::star::io::BufferSizeExceededException,
|  | com::sun::star::io::IOException
| ) |  |

reads the available number of bytes, at maximum nMaxBytesToRead.

This method is very similar to the readBytes method, except that it has different blocking behaviour. The method blocks as long as at least 1 byte is available or EOF has been reached. EOF has only been reached, when the method returns 0 and the corresponding byte sequence is empty. Otherwise, after the call, aData contains the available, but no more than nMaxBytesToRead, bytes.

Parameters

  aData | contains the data read from the stream.
  nMaxBytesToRead | The maximum number of bytes to be read from this stream during the call.

See also
  com::sun::star::io::XInputStream::readBytes

## ◆ skipBytes()

void skipBytes | ( | [in] long | nBytesToSkip | ) |
raises | ( | com::sun::star::io::NotConnectedException,
|  | com::sun::star::io::BufferSizeExceededException,
|  | com::sun::star::io::IOException
| ) |  |

skips the next nBytesToSkip bytes (must be positive).

It is up to the implementation whether this method is blocking the thread or not.

Parameters

  nBytesToSkip | number of bytes to skip

The documentation for this interface was generated from the following file:

- com/sun/star/io/XInputStream.idl